/*****************************************************************************
* Filename:          xps_sil00.c
* Version:           1.00.b
* Description:       xps_sil00 Driver Source File
* Date:              Mon Aug 09 13:09:55 2010 (by Create and Import Peripheral Wizard)
*****************************************************************************/


/***************************** Include Files *******************************/

#include "xps_sil00.h"

/************************** Function Definitions ***************************/

/**
 *
 * Enable all possible interrupts from XPS_SIL00 device.
 *
 * @param   baseaddr_p is the base address of the XPS_SIL00 device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void XPS_SIL00_EnableInterrupt(void * baseaddr_p)
{
  Xuint32 baseaddr;
  baseaddr = (Xuint32) baseaddr_p;

  /*
   * Enable all interrupt source from user logic.
   */
  XPS_SIL00_mWriteReg(baseaddr, XPS_SIL00_INTR_IPIER_OFFSET, 0x00000001);

  /*
   * Set global interrupt enable.
   */
  XPS_SIL00_mWriteReg(baseaddr, XPS_SIL00_INTR_DGIER_OFFSET, INTR_GIE_MASK);
}

/**
 *
 * Example interrupt controller handler for XPS_SIL00 device.
 * This is to show example of how to toggle write back ISR to clear interrupts.
 *
 * @param   baseaddr_p is the base address of the XPS_SIL00 device.
 *
 * @return  None.
 *
 * @note    None.
 *
 */
void XPS_SIL00_Intr_DefaultHandler(void * baseaddr_p)
{
  Xuint32 baseaddr;
  Xuint32 IntrStatus;
  Xuint32 IpStatus;
  baseaddr = (Xuint32) baseaddr_p;

  {
    IpStatus = XPS_SIL00_mReadReg(baseaddr, XPS_SIL00_INTR_IPISR_OFFSET);
    XPS_SIL00_mWriteReg(baseaddr, XPS_SIL00_INTR_IPISR_OFFSET, IpStatus);
  }

}

